#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "common.h" 

#define BIT_7_MASK	0x70 

void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_delete1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clearbutton_clicked                (GtkButton       *button,
                                        gpointer    user_data)
{
	GtkWidget* text;
	GtkTextBuffer *buffer ;
	text = lookup_widget((GtkWidget *) button, "textview1") ;
	buffer = gtk_text_view_get_buffer((GtkTextView*) text) ;
	gtk_text_buffer_set_text(buffer, "", -1);
	
}



gboolean
on_window1_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_main_quit (); 
	return FALSE;
}

void
on_manual_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkEntry *entry;
	GtkCheckButton *ar_button ;
	entry = (GtkEntry*) lookup_widget((GtkWidget *) button, "ipaddr_entry") ;
	ar_button = (GtkCheckButton*) lookup_widget((GtkWidget *) button, "autoreply_checkbutton") ;
	
	if(gtk_toggle_button_get_active((GtkToggleButton*) ar_button)) 
		artnet_send_poll(node, gtk_entry_get_text(entry), ARTNET_TTM_AUTO) ;
	else
		artnet_send_poll(node, gtk_entry_get_text(entry), ARTNET_TTM_DEFAULT) ;
	
}

void
on_scan_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkCheckButton *ar_button ;
	ar_button = (GtkCheckButton*) lookup_widget((GtkWidget *) button, "autoreply_checkbutton") ;
	
	if(gtk_toggle_button_get_active((GtkToggleButton*) ar_button)) 
		artnet_send_poll(node, NULL, ARTNET_TTM_AUTO) ;
	else
		artnet_send_poll(node, NULL, ARTNET_TTM_DEFAULT) ;
}


void on_node_scan_button_clicked(GtkButton *button, int id) 
{
	artnet_node_entry e = lookup_node_entry_by_id(node,id) ;
	gchar *gstr ;
	
	if(e != NULL) {
		gstr = g_strdup_printf("%d.%d.%d.%d", e->ip[0], e->ip[1], e->ip[2], e->ip[3]) ;
		artnet_send_poll(node, gstr, ARTNET_TTM_DEFAULT) ;
	}
}

void
on_nodebutton1_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	on_node_scan_button_clicked(button, 1) ;	
}

void
on_nodebutton2_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	on_node_scan_button_clicked(button, 2) ;
}


void
on_nodebutton3_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	on_node_scan_button_clicked(button, 3) ;
}


void
on_nodebutton4_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	on_node_scan_button_clicked(button, 4) ;
}


void
on_nodebutton5_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	on_node_scan_button_clicked(button, 5) ;
}


void
on_nodebutton6_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	on_node_scan_button_clicked(button, 6) ;
}

void
on_sendpollreplybutton_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
	artnet_send_poll_reply(node) ;
}



void
on_recvradiobutton1_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	change_active_node_to(button, node, 1) ;
}


void
on_recvradiobutton2_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	change_active_node_to(button, node, 2) ;
}


void
on_recvradiobutton3_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	change_active_node_to(button, node, 3) ;
}


void
on_recvradiobutton4_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	change_active_node_to(button, node, 4) ;
}


void
on_recvradiobutton5_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	change_active_node_to(button, node, 5) ;
}


void
on_recvradiobutton6_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	change_active_node_to(button, node, 6) ;
}

void
on_page_switch                         (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        guint            page_num,
                                        gpointer         user_data)
{

	if(page_num == 1) 
		update_recv_page((GtkWidget*) notebook, node) ;
	else if(page_num == 2) 	
		update_trans_page((GtkWidget*) notebook, node) ;
	else if(page_num == 3)
		update_remote_page((GtkWidget*) notebook, node) ;	

}


void send_art_input(GtkButton *button) {
	int8_t settings[ARTNET_MAX_PORTS] ;
	int i = 0;
	GtkCheckButton *chk_button ;
	gchar *gstr ;
		
	for(i=0; i< ARTNET_MAX_PORTS; i++) {
		gstr = g_strdup_printf("recvcheckbutton%d", i+1) ;
		chk_button = (GtkCheckButton*) lookup_widget((GtkWidget *) button, gstr) ;
		
		// got to love these magic numbers :)
		if(gtk_toggle_button_get_active((GtkToggleButton*) chk_button)) {
			settings[i] = 0x00 ;
		} else {
			// disable this input port
			settings[i] = 0x01 ;			
		}
	}
	
	artnet_send_input(node, active_node, settings) ;
	
}

void
on_recvcheckbutton1_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	send_art_input(button) ;
	

}

void
on_recvcheckbutton2_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	send_art_input(button) ;
}


void
on_recvcheckbutton4_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	send_art_input(button) ;
}


void
on_recvcheckbutton3_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	send_art_input(button) ;
}

void
on_prognodebutton_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	int8_t inAddr[ARTNET_MAX_PORTS] ;
	int8_t outAddr[ARTNET_MACSLAVE] ;
	int8_t subAddr ;
	
	int i = 0;
	GtkCheckButton *chk_button ;
	GtkSpinButton *spn_button ;
	GtkEntry *entry ;
	
	gchar *gstr ;
	const gchar *short_name, *long_name ;
	
	// short name
	chk_button = (GtkCheckButton*) lookup_widget((GtkWidget *) button, "short_progcheckbutton") ;
	entry = (GtkEntry*) lookup_widget((GtkWidget *) button, "short_progentry") ;
	
	if(gtk_toggle_button_get_active((GtkToggleButton*) chk_button))  {
		short_name = gtk_entry_get_text(entry) ;
	} else {
		short_name = ""	;
	}
	
	// long name
	chk_button = (GtkCheckButton*) lookup_widget((GtkWidget *) button, "long_progcheckbutton") ;
	entry = (GtkEntry*) lookup_widget((GtkWidget *) button, "long_progentry") ;
	
	if(gtk_toggle_button_get_active((GtkToggleButton*) chk_button))  {
		long_name = gtk_entry_get_text(entry) ;
	} else {
		long_name = ""	;
	}
	
	// input ports
	for(i=0; i< ARTNET_MAX_PORTS; i++) {
		gstr = g_strdup_printf("input%i_progcheckbutton", i+1) ;
		chk_button = (GtkCheckButton*) lookup_widget((GtkWidget *) button, gstr) ;
		gstr = g_strdup_printf("input%i_spinbutton", i+1) ;
		spn_button = (GtkSpinButton*) lookup_widget((GtkWidget *) button, gstr) ;
		
		// got to love these magic numbers :)
		if(gtk_toggle_button_get_active((GtkToggleButton*) chk_button)) {
			inAddr[i] =  BIT_7_MASK |  gtk_spin_button_get_value_as_int(spn_button);
		} else {
			// disable this input port
			inAddr[i] = ARTNET_ADDRESS_NO_CHANGE ;			
		}
	}
	
	for(i=0; i< ARTNET_MAX_PORTS; i++) {
		gstr = g_strdup_printf("input%i_progcheckbutton", i+1) ;
		chk_button = (GtkCheckButton*) lookup_widget((GtkWidget *) button, gstr) ;
		gstr = g_strdup_printf("input%i_spinbutton", i+1) ;
		spn_button = (GtkSpinButton*) lookup_widget((GtkWidget *) button, gstr) ;
			
		// got to love these magic numbers :)
		if(gtk_toggle_button_get_active((GtkToggleButton*) chk_button)) {
			outAddr[i] = BIT_7_MASK | gtk_spin_button_get_value_as_int(spn_button) ;
		} else {
			// disable this input port
			outAddr[i] = ARTNET_ADDRESS_NO_CHANGE ;			
		}
	}
	
	chk_button = (GtkCheckButton*) lookup_widget((GtkWidget *) button, "subnet_progcheckbutton") ;
	spn_button = (GtkSpinButton*) lookup_widget((GtkWidget *) button, "subnet_spinbutton") ;
			
	// got to love these magic numbers :)
	if(gtk_toggle_button_get_active((GtkToggleButton*) chk_button)) {
		subAddr = BIT_7_MASK | gtk_spin_button_get_value_as_int(spn_button);
	} else {
		// disable this input port
		subAddr = ARTNET_ADDRESS_NO_CHANGE ;			
	}
	
	artnet_send_address(node, active_node, short_name,long_name, inAddr, outAddr, subAddr, ARTNET_PC_NONE) ;
}

void
on_resetprogbutton                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int8_t inAddr[ARTNET_MAX_PORTS] ;
	int8_t outAddr[ARTNET_MACSLAVE] ;
	int8_t subAddr ;
	
	int i = 0 ;
	
	// input ports
	for(i=0; i< ARTNET_MAX_PORTS; i++) {
		inAddr[i] = 0x00 ;
	}
	
	for(i=0; i< ARTNET_MAX_PORTS; i++) {
		outAddr[i] = 0x00;
	}
	
	subAddr = 0x00 ;
	
	artnet_send_address(node, active_node, "No Name","No Name", inAddr, outAddr, subAddr, ARTNET_PC_NONE) ;
}




void
trans_vscale2_value_changed            (GtkRange        *range,
                                        gpointer         user_data)
{
	transmit(node, 2, range) ;
}


void
trans_vscale4_value_changed            (GtkRange        *range,
                                        gpointer         user_data)
{
	transmit(node, 4, range) ;
}


void
trans_vscale1_value_changed            (GtkRange        *range,
                                        gpointer         user_data)
{
	transmit(node, 1, range) ;
}


void
trans_vscale3_value_changed            (GtkRange        *range,
                                        gpointer         user_data)
{
	transmit(node, 3, range) ;
}

void
on_button34_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  if(! transmiting) {
  	g_timeout_add(1000/ TICKS_PER_SECOND, tx_timeout, (gpointer) button) ;
	 transmiting = 1 ;
  }

}


void
on_button33_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  if(transmiting)
	 transmiting = 0 ;
}

void
on_tod_request_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	artnet_send_tod_request(node) ;
}
